
if TUNING.IAI_MULTI_CRAFT then
	return
end

local _G = GLOBAL

TUNING.IAI_MULTI_CRAFT = true

Assets = {
	Asset("ATLAS", "images/iai_ing_mult.xml"),
}

local banitem = {brainjellyhat = true}
local equip_items = {}

local hook_fn = nil
local restore_fn = nil
local createbutton_fn = nil
local last_popup = nil
local is_crafting = nil

local function refreshrecipes(player)
	player = player or _G.GetPlayer()
	
	if player.HUD then
		player.HUD.controls.crafttabs:UpdateRecipes()
	end
end

local function hookglobalrecipe()
	if hook_fn then
		hook_fn()
		hook_fn = nil
	end
end

local function restoreglobalrecipe()
	if restore_fn then
		restore_fn()
		restore_fn = nil
	end
end

local function killbutton(self)
	if self.iai_ing_mult then
		self.iai_ing_mult:Kill()
		self.iai_ing_mult = nil
		
		-- print("删除 button", self.recipe and self.recipe.name)
	end
end

_G.require("widgets/widgetutil")
local _DoRecipeClick = _G.DoRecipeClick
_G.DoRecipeClick = function(...)
	-- print("点击按钮")
	
	hookglobalrecipe()
	
	local _ret = _DoRecipeClick(...)
	
	is_crafting = true
	
	-- print("CRAFTING !!!!!!!!!!!!!!!")
	
	return _ret
end

AddClassPostConstruct("widgets/crafting", function(self)
	local old = self.UpdateRecipes
	self.UpdateRecipes = function(self)
		if old then old(self) end
		
		if last_popup then
			-- print("滚动刷新 ！！")
			
			last_popup:Refresh()
		end
	end
end)

AddGlobalClassPostConstruct("bufferedaction", "BufferedAction", function(self)
	local old = self.Fail
	self.Fail = function(self)
		if self.doer == _G.GetPlayer() then
			is_crafting = nil
			
			-- print("动作失败", self.doer, self.action and self.action.id or "nil")
			
			restoreglobalrecipe()
		end
		
		old(self)
	end
	
	local old = self.Succeed
	self.Succeed = function(self)
		if self.doer == _G.GetPlayer() then
			is_crafting = nil
			
			-- print("动作成功", self.doer, self.action and self.action.id or "nil")
			
			restoreglobalrecipe()
		end
		
		old(self)
	end
end)

AddComponentPostInit("equippable", function(self)
	local old = self.Equip
	self.Equip = function(self, owner, ...)
		local _owner = owner
		if owner == _G.GetPlayer() then
			equip_items[self.inst] = _owner.components.builder.ingredientmod
			
			old(self, owner, ...)
			
			if equip_items[self.inst] ~= _owner.components.builder.ingredientmod then
				-- print("建造倍率变化！！！！", self.inst, equip_items[self.inst], "->", _owner.components.builder.ingredientmod)
				
				banitem[self.inst.prefab] = true
				
				refreshrecipes(_owner)
			else
				equip_items[self.inst] = nil
			end
		else
			old(self, owner, ...)
		end
	end
	
	local old = self.Unequip
	self.Unequip = function(self, owner, ...)
		local _owner = owner
		if owner == _G.GetPlayer() then
			old(self, owner, ...)
			
			if equip_items[self.inst] then
				-- print("建造倍率还原！", self.inst, equip_items[self.inst], "->", _owner.components.builder.ingredientmod)
				
				refreshrecipes(_owner)
				
				equip_items[self.inst] = nil
			end
		else
			old(self, owner, ...)
		end
	end
end)

local Widget = _G.require("widgets/widget")
local ImageButton = _G.require("widgets/imagebutton")
AddClassPostConstruct("widgets/recipepopup", function(self)
	local old = self.Refresh
	self.Refresh = function(...)
		old(...)
		
		killbutton(self)
		
		createbutton_fn = nil
		
		if self.shown then
			restoreglobalrecipe()
			
			local ori_recipe = self.recipe
			local hook_recipe = nil
			
			if ori_recipe then
				for k,v in pairs(self.owner.components.inventory.equipslots) do
					if banitem[v.prefab] then
						return
					end
				end
				
				local structure = ori_recipe.placer ~= nil or string.find(ori_recipe.name, "interior_") ~= nil
				local shouldshow = self.button.shown and self.button:IsEnabled()
				
				if not structure and shouldshow then
					hook_recipe = _G.deepcopy(ori_recipe)
					local button = self.button
					local pos = button:GetPosition()
					local owner = self.owner
					local mult = 1
					local buttontext = button:GetText() or ""
					local freebuild = owner.components.builder.freebuildmode
					local ingsui = {}
					local max = 9999
					local reset = true
					local multed = nil
					local x_pos = 100
					local y_pos = 35
					local plus = 5
					
					local function refreshdisplay(mult, init)
						local display_num = (hook_recipe.numtogive or 1) *mult
						
						button:SetText(buttontext..(display_num ~= 1 and " x "..display_num or ""))
						
						for k,v in pairs(ingsui) do
							k.quant:SetString(string.format("%d/%d", v.has, v.need *mult))
						end
						
						if not init then
							multed = true
						end
					end
					
					local function hookrecipe()
						if multed and ori_recipe and hook_recipe then
							if (ori_recipe.numtogive or 1) ~= (hook_recipe.numtogive or 1) *mult then
								local mod = owner.components.builder.ingredientmod
								
								-- print("HOOK 配方！", ori_recipe.name, hook_recipe.name, ori_recipe.numtogive or 1, "->", (hook_recipe.numtogive or 1) *mult)
								-- print("ori_recipe")
								-- _G.print_table(ori_recipe.ingredients[1])
								
								ori_recipe.numtogive = (hook_recipe.numtogive or 1) *mult
								
								for k,v in pairs(ori_recipe.ingredients) do
									for kk,vv in pairs(hook_recipe.ingredients) do
										if v.type == vv.type then
											v.amount = math.ceil((math.ceil(vv.amount *mod) *mult) /mod)
											
											break
										end
									end
								end
								
								if ori_recipe.character_ingredients then
									for k,v in pairs(ori_recipe.character_ingredients) do
										for kk, vv in pairs(hook_recipe.character_ingredients) do
											if v.type == vv.type then
												v.amount = vv.amount *mult
												
												break
											end
										end
									end
								end
								
								-- print("hook_recipe")
								-- _G.print_table(ori_recipe.ingredients[1])
							end
						end
					end
					
					local function restorerecipe()
						if reset then
							reset = nil
							
							if ori_recipe and hook_recipe then
								if (ori_recipe.numtogive or 1) ~= (hook_recipe.numtogive or 1) then
									-- print("还原配方！", ori_recipe.name, hook_recipe.name, ori_recipe.numtogive or 1, "->", hook_recipe.numtogive or 1)
									
									-- print(_G.debug.traceback())
									
									ori_recipe.numtogive = hook_recipe.numtogive
									
									for k,v in pairs(ori_recipe.ingredients) do
										for kk,vv in pairs(hook_recipe.ingredients) do
											if v.type == vv.type then
												v.amount = vv.amount
												
												break
											end
										end
									end
									
									if ori_recipe.character_ingredients then
										for k,v in pairs(ori_recipe.character_ingredients) do
											for kk, vv in pairs(hook_recipe.character_ingredients) do
												if v.type == vv.type then
													v.amount = vv.amount
													
													break
												end
											end
										end
									end
								end
								
								ori_recipe = nil
								hook_recipe = nil
								restore_fn = nil
								
								refreshrecipes(owner)
							end
						end
					end
					
					local function getatlas(name, right)
						name = name or ""
						right = right and "right" or "left"
						name = "iai_ing_"..right..name
						
						return "images/iai_ing_mult.xml", name..".tex", name.."_light.tex", name..".tex"
					end
					
					for k,v in pairs(self.contents.children) do
						if v.name == "IngredientUI" then
							local str = v.quant:GetString()
							local has, need = string.match(str, "(%d+)/(%d+)")
							
							-- 重新显示正确的血量/精神消耗值，这个不会被半价，官方的显示有问题
							if v.ing and v.ing.texture and (v.ing.texture == "decrease_health.tex" or v.ing.texture == "decrease_sanity.tex") then
								need = math.ceil(need /owner.components.builder.ingredientmod)
							end
							
							ingsui[v] = {has = has, need = need, max = math.floor(has /need)}
							
							-- _G.print_table(v)
						end
					end
					
					for k,v in pairs(ingsui) do
						max = math.min(max, v.max)
					end
					
					local function createbutton()
						killbutton(self)
						
						if self.focus and not structure and shouldshow and not self.iai_ing_mult then
							self.iai_ing_mult = self.contents:AddChild(Widget(""))
							self.iai_ing_mult:SetPosition(pos.x, pos.y +5, 0)
							
							local root = self.iai_ing_mult
							
							local less = root:AddChild(ImageButton(getatlas()))
							less:SetPosition(-x_pos, y_pos, 0)
							less:SetOnClick(function()
								mult = math.max(1, mult -1)
								refreshdisplay(mult)
								restore_fn = restorerecipe
							end)
							
							local less2 = root:AddChild(ImageButton(getatlas(2)))
							less2:SetPosition(-x_pos, 0, 0)
							less2:SetOnClick(function()
								mult = math.max(1, mult -plus)
								refreshdisplay(mult)
								restore_fn = restorerecipe
							end)
							
							local less3 = root:AddChild(ImageButton(getatlas(3)))
							less3:SetPosition(-x_pos, -y_pos, 0)
							less3:SetOnClick(function()
								mult = 1
								refreshdisplay(mult)
								restore_fn = restorerecipe
							end)
							
							local more = root:AddChild(ImageButton(getatlas(nil, true)))
							more:SetPosition(x_pos, y_pos, 0)
							more:SetOnClick(function()
								mult = freebuild and mult +1 or math.max(1, math.min(max, mult +1))
								refreshdisplay(mult)
								restore_fn = restorerecipe
							end)
							
							local more2 = root:AddChild(ImageButton(getatlas(2, true)))
							more2:SetPosition(x_pos, 0, 0)
							more2:SetOnClick(function()
								mult = freebuild and mult +plus or math.max(1, math.min(max, mult +plus))
								refreshdisplay(mult)
								restore_fn = restorerecipe
							end)
							
							local more3 = root:AddChild(ImageButton(getatlas(3, true)))
							more3:SetPosition(x_pos, -y_pos, 0)
							more3:SetOnClick(function()
								mult = freebuild and mult +plus or math.max(1, max)
								refreshdisplay(mult)
								restore_fn = restorerecipe
							end)
							
							-- print("生成 button", self.recipe and self.recipe.name)
						end
					end
					
					refreshdisplay(1, true)
					
					hook_fn = hookrecipe
					
					createbutton_fn = createbutton
					
					createbutton()
				end
			end
		end
	end
	
	local old = self.OnGainFocus
	self.OnGainFocus = function(...)
		-- print("OnGainFocus", self.recipe and self.recipe.name)
		
		if old then old(...) end
		
		if createbutton_fn then
			createbutton_fn()
		end
		
		last_popup = self
	end
	
	local old = self.OnLoseFocus
	self.OnLoseFocus = function(...)
		-- print("OnLoseFocus", self.recipe and self.recipe.name)
		
		if old then old(...) end
		
		killbutton(self)
	end
	
	local old = self.OnHide
	self.OnHide = function(...)
		if old then old(...) end
		
		killbutton(self)
		
		if not is_crafting then
			-- print("NOT CRAFTING")
			
			restoreglobalrecipe()
		end
		
		-- print("Hide", self.recipe and self.recipe.name)
	end
end)
